---
title: StyleSheetList
slug: Web/API/StyleSheetList
tags:
  - API
  - CSSOM
  - NeedsContent
  - NeedsUpdate
---
<div>{{APIRef("CSSOM")}}</div>

<p>The <code>StyleSheetList</code> interface represents a list of {{domxref("StyleSheet")}}.</p>

<p>It is an array-like object but can't be iterated over using {{jsxref("Array")}} methods. However It can be iterated over in a standard {{jsxref("Statements/for", "for")}} loop over its indices, or converted to an {{jsxref("Array")}}.</p>

<h2 id="Example">Examples</h2>

<h3 id="Get_document_styleSheet_objects_with_for_loop">Get document <a href="/en-US/docs/Web/API/CSSStyleSheet">styleSheet</a> objects with for loop</h3>

<pre class="brush: js">for (let i = 0; i &lt; document.styleSheets.length; i++) {
  let styleSheet = document.styleSheets[i];
}</pre>

<h3 id="Get_all_CSS_rules_for_the_document_using_Array_methods">Get all CSS rules for the document using Array methods</h3>

<pre>const allCSS = [...document.styleSheets]
  .map(styleSheet =&gt; {
    try {
      return [...styleSheet.cssRules]
        .map(rule =&gt; rule.cssText)
        .join('');
    } catch (e) {
      console.log('Access to stylesheet %s is denied. Ignoring...', styleSheet.href);
    }
  })
  .filter(Boolean)
  .join('\n');</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th>Specification</th>
   <th>Status</th>
   <th>Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("CSSOM", "#the-stylesheetlist-interface", 'CSSStyleSheetList')}}</td>
   <td>{{Spec2("CSSOM")}}</td>
   <td></td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.StyleSheetList")}}</p>
